document.addEventListener("DOMContentLoaded", () => {
  let start = new Date;
  const lifespan = {{ lifespan }}

  async function postData(url = '', data = {}) {
    const response = await fetch(url, {
      method: 'POST',
      mode: 'same-origin',
      cache: 'no-cache',
      credentials: 'same-origin', // include, *same-origin, omit
      headers: {
        'X-CSRFToken': '{{ session.token }}',
        'Content-Type': 'application/json',
      },
      redirect: 'follow',
      referrerPolicy: 'no-referrer',
      body: JSON.stringify(data)
    })

    start = new Date;
    return response.json();
  }

  setInterval(() => {
    const time = parseInt((lifespan * 60) - (new Date - start) / 1000);
    let minutes = Math.floor(time / 60);
    if(minutes < 10) {
      minutes = "0" + minutes
    }
    let hours = Math.floor(minutes / 60)
    if(hours < 10) {
      hours = "0" + hours
    }
    let seconds = time - minutes * 60 - hours * (60**2)
    if(seconds < 10) {
      seconds = "0" + seconds
    }
    if(hours > -1 && minutes > -1 && seconds > -1) {
      document.querySelector('.timer').innerText = `${hours}:${minutes}:${seconds}`
    }
    if(parseInt((lifespan * 60) - (new Date - start) / 1000) < 0) {
      window.location = "/logout"
    }
  }, 1000)

  document.querySelector('.timer').onclick = (e) => {
    e.preventDefault()
    postData('/keepalive', {})
    .then(data => {
      start = new Date;
    })
  }

  refreshMenu = (updateDB = true, items = false) => {
    if (document.querySelector('main') !== null) {
      document.querySelector('main').innerHTML = ""
      menu.forEach((cat, index) => {
        const card = categoryCard(cat.cid, index, cat.cname)
        document.querySelector('main').append(card)
        refreshItems(cat.cid, JSON.parse(cat.items), index)
      })
      if(updateDB) {
        postData('/update-categories', menu)
      }
      start = new Date;
    }
  }

  refreshItems = (cid, items, cindex) => {
    const cont = document.querySelector(`div[data-cid='${cid}'] .item-list`)
    cont.innerHTML = ""
    const itemUl = document.createElement('UL')
    itemUl.classList.add('list-group')
    if (items.length > 0) {
      items.forEach((item, index) => {
        const hot = document.createElement('IMG')
        const gf = document.createElement('IMG')
        const veg = document.createElement('IMG')
        hot.src = "{{ public_path }}/images/hot.svg"
        hot.classList.add('icon-spicy')
        hot.title = "{{ l.spicy }}"
        gf.src = "{{ public_path }}/images/gf.svg"
        gf.title = "{{ l.glutenfree }}"
        gf.classList.add('icon-gf')
        veg.src = "{{ public_path }}/images/veg.svg"
        veg.title = "{{ l.vegetarian }}"
        veg.classList.add('icon-veg')
        item.i_order = index
        const itemTitle = document.createElement('DIV')
        itemTitle.classList.add('item-title')
        let lineNumber = "" + cindex
        if(index < 10) {
          lineNumber += "0"
        }
        lineNumber += index + 1
        itemTitle.append(lineNumber, ". ", item.title)
        if(item.spicy === 1) {
          itemTitle.append(hot)
        }
        if(item.gf === 1) {
          itemTitle.append(gf)
        }
        if(item.veg === 1) {
          itemTitle.append(veg)
        }

        const itemDesc = document.createElement('SMALL')
        itemDesc.classList.add('item-description')
        itemDesc.append(item.description)

        const itemTexts = document.createElement('DIV')
        itemTexts.classList.add('col-12', 'col-lg-9')
        itemTexts.append(itemTitle, itemDesc)

        const itemPrices = document.createElement('DIV')
        itemPrices.classList.add('text-left', 'text-lg-right', 'prices')

        const itemActions = document.createElement('DIV')
        itemActions.classList.add('d-flex', 'item-actions', 'justify-content-end', 'align-items-end')

        if(index > 0) {
          const itemMoveUp = document.createElement('I')
          itemMoveUp.classList.add('fa', 'fa-arrow-up')
          itemMoveUp.title = '{{ l.up }}'
          itemMoveUp.onclick = () => {
            postData('/move-item', {
              'id': item.id,
              'cid': cid,
              'prev': items[index - 1].id,
              'dir': 'up'
            })
            .then(data => {
              refreshItems(cid, data, cindex)
              hideModal()
            })
          }
          itemActions.append(itemMoveUp)
        }

        if(index < items.length - 1) {
          const itemMoveDown = document.createElement('I')
          itemMoveDown.classList.add('fa', 'fa-arrow-down')
          itemMoveDown.title = '{{ l.down }}'
          itemMoveDown.onclick = () => {
            postData('/move-item', {
              'id': item.id,
              'cid': cid,
              'next': items[index + 1].id,
              'dir': 'down'
            })
            .then(data => {
              refreshItems(cid, data, cindex)
              hideModal()
            })
          }
          itemActions.append(itemMoveDown)
        }

        const itemEdit = document.createElement('I')
        itemEdit.classList.add('fa', 'fa-pencil')
        itemEdit.title = '{{ l.edit }}'
        itemEdit.onclick = () => {
          showModal({
            m_class: 'edit-item',
            title: `{{ l.edit }}: ${item.title}`,
            body: itemForm({
              title: item.title,
              description: item.description,
              s_price: item.sm_price,
              l_price: item.lg_price,
              spicy: item.spicy,
              veg: item.veg,
              gf: item.gf
            }),
            actionText: '{{ l.edit }}',
            actionFunc: () => {
              data = {
                id: item.id,
                cid: cid,
                i_order: index,
                title: document.querySelector('#id_title').value,
                description: document.querySelector('#id_description').value,
                s_price: document.querySelector('#id_price_sm').value,
                l_price: document.querySelector('#id_price_lg').value,
                spicy: document.querySelector('#id_spicy').checked,
                veg: document.querySelector('#id_veg').checked,
                gf: document.querySelector('#id_gf').checked
              }
              postData('edit-item', data)
              .then(data => {
                menu = data
                refreshItems(cid, data, cindex)
                hideModal()
              })
            }
          })
        }

        const itemDelete = document.createElement('I')
        itemDelete.classList.add('fa', 'fa-times')
        itemDelete.title = '{{ l.delete }}'
        itemDelete.onclick = () => {
          showModal({
            m_class: 'delete',
            title:`{{ l.delete_item }}: ${item.title}`,
            body: '{{ l.del_item }}',
            actionText: '{{ l.delete }}',
            actionFunc: () => {
              postData('/delete-item', {'id': item.id})
              .then(data => {
                menu = data
                refreshItems(cid, data, cindex)
                hideModal()
              })
            }
          })
        }

        itemActions.append(itemEdit, itemDelete)

        if(item.sm_price != null) {
          const smallText = document.createElement('SMALL')
          smallText.append('{{ l.s_price }}')

          const smallPrice = document.createElement('SPAN')
          {% if session.currency.symbol_pos == 'before' %}
          smallPrice.append(smallText, "{{ session.currency.symbol }}", item.sm_price)
          {% else %}
          smallPrice.append(smallText, item.sm_price, "{{ session.currency.symbol }}")
          {% endif %}
          itemPrices.append(smallText, smallPrice)

          const largeText = document.createElement('SMALL')
          largeText.append('{{ l.l_price }}')

          const largePrice = document.createElement('SPAN')
          {% if session.currency.symbol_pos == 'before' %}
          largePrice.append(largeText, "{{ session.currency.symbol }}", item.lg_price)
          {% else %}
          largePrice.append(largeText, item.lg_price, "{{ session.currency.symbol }}")
          {% endif %}
          itemPrices.append(largeText, largePrice)
        } else {
          const price = document.createElement('SPAN')
          {% if session.currency.symbol_pos == 'before' %}
          price.append("{{ session.currency.symbol }}", item.lg_price)
          {% else %}
          price.append(item.lg_price, "{{ session.currency.symbol }}")
          {% endif %}
          itemPrices.append(price)
        }

        const itemLi = document.createElement('LI')
        itemLi.classList.add('list-group-item')
        itemLi.draggable = false //TODO solve drag-and-drop
        itemLi.dataset['iorder'] = index

        const itemRight = document.createElement('DIV')
        itemRight.classList.add('d-flex', 'flex-column', 'col-12', 'col-lg-3')

        itemRight.append(itemPrices, itemActions)

        const itemLiInner = document.createElement('DIV')
        itemLiInner.classList.add('row')
        itemLiInner.append(itemTexts, itemRight)

        itemLi.append(itemLiInner)

        itemUl.append(itemLi)
      })
      cont.append(itemUl)
    }

    start = new Date;
  }

  refreshTranslator = () => {
    let show = 1

    document.querySelector('#lang_tabs').innerHTML = ""
    actLangs.forEach(lng => {
      const tab_a = document.createElement('A')
      const tab_li = document.createElement('LI')
      tab_a.id = `${lng.code}-tab`
      tab_a.dataset['toggle'] = 'tab'
      tab_a.dataset['tab'] = lng.code
      tab_a.role = 'tab'
      tab_a.href = `#${lng.code}`
      tab_a.append(lng.name)
      tab_a.classList.add('nav-link')
      if (show === 1) {
        tab_a.classList.add('active')
      }
      tab_li.classList.add('nav-item')
      tab_li.append(tab_a)
      document.querySelector('#lang_tabs').append(tab_li)

      if(menu !== null) {
        const tab_content = document.createElement('DIV')
        tab_content.classList.add('tab-pane')
        if (show === 1) {
          tab_content.classList.add('active', 'show')
        }
        show = 0
        menu.forEach((cat, index) => {
          const fCatRow = document.createElement('DIV')
          fCatRow.classList.add('form-group', 'row', 'form-group-category')
          const cTitleLabel = document.createElement('LABEL')
          cTitleLabel.htmlFor = `${lng.code}_ctitle_${index}`
          cTitleLabel.classList.add('col-form-label', 'col-6')
          cTitleLabel.append(cat.cname)
          const cTitleDiv = document.createElement('DIV')
          cTitleDiv.classList.add('col-6')
          const cTitleInput = document.createElement('INPUT')
          cTitleInput.type = 'text'
          cTitleInput.id = `${lng.code}_ctitle_${index}`
          cTitleInput.classList.add('form-control')
          if (lng.rtl === "1") {
            cTitleInput.dir = "rtl"
          }
          cTitleDiv.append(cTitleInput)
          fCatRow.append(cTitleLabel, cTitleDiv)
          tab_content.append(fCatRow)
          JSON.parse(cat.items).forEach((itm, index) => {
            const fRow = document.createElement('DIV')
            fRow.classList.add('form-group', 'row')
            const iTitleLabel = document.createElement('LABEL')
            iTitleLabel.htmlFor = `${lng.code}_ititle_${index}`
            iTitleLabel.classList.add('col-form-label', 'col-6', 'title-label')
            iTitleLabel.append(itm.title)
            const iTitleDiv = document.createElement('DIV')
            iTitleDiv.classList.add('col-6')
            const iTitleInput = document.createElement('INPUT')
            iTitleInput.type = 'text'
            iTitleInput.id = `${lng.code}_ititle_${index}`
            iTitleInput.classList.add('form-control')
            if (lng.rtl === "1") {
              iTitleInput.dir = "rtl"
            }
            iTitleDiv.append(iTitleInput)

            fRow.append(iTitleLabel, iTitleDiv)
            tab_content.append(fRow)

            const fDescRow = document.createElement('DIV')
            fDescRow.classList.add('form-group', 'row', 'desc-form-group')
            const iDescLabel = document.createElement('LABEL')
            iDescLabel.htmlFor = `${lng.code}_idesc_${index}`
            iDescLabel.classList.add('col-form-label', 'col-6')
            iDescLabel.append(itm.description)
            const iDescDiv = document.createElement('DIV')
            iDescDiv.classList.add('col-6')
            const iDescInput = document.createElement('INPUT')
            iDescInput.type = 'text'
            if (lng.rtl === "1") {
              iDescInput.dir = "rtl"
            }
            iDescInput.id = `${lng.code}_idesc_${index}`
            iDescInput.classList.add('form-control')
            iDescDiv.append(iDescInput)

            fDescRow.append(iDescLabel, iDescDiv)
            tab_content.append(fDescRow)
          })
        })
        document.querySelector("#myTabContent").innerHTML = ""
        document.querySelector("#myTabContent").append(tab_content)
      }
    })
  }

  if (document.querySelector('#language_select') !== null) {
    document.querySelector('#language_select').onchange = () => {
      if (document.querySelector('#language_select').selectedIndex !== 0) {
        if (document.querySelector('#add_language') !== null) {
          document.querySelector('#add_language').disabled = false
          document.querySelector('#add_language').onclick = () => {
            const selectedLang = {
              'code': document.querySelector('#language_select').value,
              'name': document.querySelector('#language_select')[document.querySelector('#language_select').selectedIndex].innerText,
              'rtl': document.querySelector('#language_select')[document.querySelector('#language_select').selectedIndex].dataset['rtl']
            }
            if(actLangs.indexOf(selectedLang) === -1) {
              actLangs.push(selectedLang)
              document.querySelector('#language_select').remove(document.querySelector('#language_select').selectedIndex)
              document.querySelector('#language_select').selectedIndex = 0
              refreshTranslator()
            }
          }
        }
      } else {
        document.querySelector('#add_language').disabled = true
      }
    }
  }

  if (document.querySelector('#profile_form') !== null) {
    document.querySelector('#profile_form').onsubmit = (e) => {
      document.querySelector('.alert-danger').classList.remove('d-block')
      document.querySelector('.alert-success').classList.remove('d-block')
      document.querySelector('.alert-success').classList.add('d-none')
      document.querySelector('.alert-danger').classList.add('d-none')
      e.preventDefault()
      let lng = "en"
      document.getElementsByName('preflang').forEach(lng_radio => {
        console.debug(lng_radio.checked);
        if (lng_radio.checked === true) {
          lng = lng_radio.value
        }
      })

      let data = {
        'lang': lng,
        'currency': document.querySelector('#currency').value,
        'rest_name': document.querySelector('#rest_name').value,
        'rest_desc': document.querySelector('#rest_desc').value,
        'rest_footnote': document.querySelector('#rest_footnote').value,
      }
      postData('/profile', data)
      .then(data => {
        if (data === "OK") {
          document.querySelector('.alert-success').classList.remove('d-none')
          document.querySelector('.alert-success').classList.add('d-block')
        } else {
          document.querySelector('.error-message').innerText = data
          document.querySelector('.alert-danger').classList.remove('d-none')
          document.querySelector('.alert-danger').classList.add('d-block')
        }
      })
    }
  }

  if (document.querySelector('#new_cat') !== null) {
    document.querySelector('#new_cat').onkeyup = (e) => {
      const add_btn = document.querySelector('#add_cat')
      if (document.querySelector('#new_cat').value !== "") {
        if (add_btn.disabled === true) {
          add_btn.disabled = false
          add_btn.onclick = (event) => {
            event.preventDefault()
            sendNewCategory()
          }
        }

        sendNewCategory = () => {
          postData('/add-category', {name: document.querySelector('#new_cat').value})
          .then(data => {
            menu = data
            refreshMenu(false)
            document.querySelector('#new_cat').value = ""
          })
        }
      } else {
        add_btn.disabled = true
        add_btn.removeAttribute('onclick')
      }
    }
  }

  hideModal = () => {
    document.querySelector('.modal').style.display = 'none'
    document.querySelector('.modal').classList.remove('show')
  }

  showModal = (props) => {
    if(document.querySelector('.modal-dialog') !== null) {
      document.querySelector('.modal-dialog').className = `modal-dialog ${props.m_class}`
    }

    if(document.querySelector('.modal-title') !== null) {
      document.querySelector('.modal-title').innerHTML = props.title || ''
    }

    if(document.querySelector('.modal-body') !== null) {
      document.querySelector('.modal-body').innerHTML = ""
      document.querySelector('.modal-body').append(props.body)
    }

    document.querySelector('.modal-close').onclick = () => {
      hideModal()
    }

    document.querySelector('#modal_cancel').onclick = () => {
      hideModal()
    }
    document.querySelector('#modal_action').innerText = props.actionText || "OK"
    document.querySelector('#modal_action').onclick = props.actionFunc

    document.querySelector('.modal').style.display = 'block'
    document.querySelector('.modal').classList.add('show')
  }

  itemForm = (props) => {
    let lbl = document.createElement("LABEL")
    lbl.htmlFor = 'id_title'
    lbl.append("{{ l.title }}")

    let tinput = document.createElement("INPUT")
    tinput.type = "text"
    tinput.classList.add('form-control')
    tinput.id = 'id_title'
    tinput.value = props.title || ''
    tinput.name = 'title'

    let fgroup = document.createElement("DIV")
    fgroup.classList.add('form-group')
    fgroup.append(lbl, tinput)

    const add_form = document.createElement("FORM")
    add_form.id = "form_add_item"
    add_form.append(fgroup)

    lbl = document.createElement("LABEL")
    lbl.htmlFor = 'id_description'
    lbl.append("{{ l.description }}")

    tinput = document.createElement("INPUT")
    tinput.type = "text"
    tinput.classList.add('form-control')
    tinput.id = 'id_description'
    tinput.name = 'description'
    tinput.value = props.description || ''

    fgroup = document.createElement("DIV")
    fgroup.classList.add('form-group')
    fgroup.append(lbl, tinput)

    add_form.append(fgroup)

    lbl = document.createElement("H5")
    lbl.append("{{ l.prices }}")

    add_form.append(lbl)


    const l_curr = document.createElement("SPAN")
    l_curr.classList.add('input-group-text')
    l_curr.append("{{ session.currency.symbol }}")

    lbl = document.createElement("LABEL")
    lbl.append("{{ l.price }}")

    const lg_price = document.createElement("INPUT")
    lg_price.type = "number"
    lg_price.step = 0.01
    lg_price.classList.add('form-control')
    lg_price.id = 'id_price_lg'
    lg_price.name = 'price_lg'
    lg_price.value = props.l_price || ''

    const l_input_group = document.createElement('DIV')
    l_input_group.classList.add('input-group')

    {% if session.currency.symbol_pos == 'before' %}

    const l_prep = document.createElement('DIV')
    l_prep.classList.add('input-group-prepend')
    l_prep.append(l_curr)
    l_input_group.append(l_prep, lg_price)

    {% else %}

    const l_appnd = document.createElement('DIV')
    l_appnd.classList.add('input-group-append')
    l_appnd.append(l_curr)
    l_input_group.append(lg_price, l_appnd)

    {% endif %}

    const l_fgroup = document.createElement("DIV")
    l_fgroup.classList.add('col-6')
    l_fgroup.append(lbl, l_input_group)

    const priceCont = document.createElement('DIV')
    priceCont.classList.add('form-row')

    priceCont.append(l_fgroup)

    lbl = document.createElement("LABEL")
    lbl.append("{{ l.s_price }}", " (", "{{ l.optional }}", ")")

    const s_curr = document.createElement("SPAN")
    s_curr.classList.add('input-group-text')
    s_curr.append("{{ session.currency.symbol }}")

    const sm_price = document.createElement("INPUT")
    sm_price.type = "number"
    sm_price.step = 0.01
    sm_price.classList.add('form-control')
    sm_price.id = 'id_price_sm'
    sm_price.name = 'price_sm'
    sm_price.value = props.s_price || ''

    const s_input_group = document.createElement('DIV')
    s_input_group.classList.add('input-group')

    {% if session.currency.symbol_pos == 'before' %}

    const s_prep = document.createElement('DIV')
    s_prep.classList.add('input-group-prepend')
    s_prep.append(s_curr)
    s_input_group.append(s_prep, sm_price)

    {% else %}

    const s_appnd = document.createElement('DIV')
    s_appnd.classList.add('input-group-append')
    s_appnd.append(s_curr)
    s_input_group.append(sm_price, s_appnd)

    {% endif %}

    const s_fgroup = document.createElement("DIV")
    s_fgroup.classList.add('col-6')
    s_fgroup.append(lbl, s_input_group)

    priceCont.append(s_fgroup)

    add_form.append(priceCont)



    const veg_input = document.createElement('INPUT')
    veg_input.type = "checkbox"
    veg_input.classList.add('form-check-input')
    veg_input.id = "id_veg"
    veg_input.name = "veg"
    if(props.veg !== null) {
      veg_input.checked = (props.veg === 1) ? true : false
    }

    const veg_label = document.createElement('LABEL')
    veg_label.htmlFor = "id_veg"
    veg_label.classList.add('form-check-label')
    veg_label.append("{{ l.vegetarian }}")

    const veg_cont = document.createElement('DIV')
    veg_cont.classList.add('form-check')

    veg_cont.append(veg_input, veg_label)

    const veg = document.createElement('DIV')
    veg.classList.add('col-12', 'col-lg-4')
    veg.append(veg_cont)

    const gf_input = document.createElement('INPUT')
    gf_input.type = "checkbox"
    gf_input.classList.add('form-check-input')
    gf_input.id = "id_gf"
    gf_input.name = "gf"
    if(props.gf !== null) {
      gf_input.checked = (props.gf === 1) ? true : false
    }

    const gf_label = document.createElement('LABEL')
    gf_label.htmlFor = "id_gf"
    gf_label.classList.add('form-check-label')
    gf_label.append("{{ l.glutenfree }}")

    const gf_cont = document.createElement('DIV')
    gf_cont.classList.add('form-check')

    gf_cont.append(gf_input, gf_label)

    const gf = document.createElement('DIV')
    gf.classList.add('col-12', 'col-lg-4')
    gf.append(gf_cont)

    const spicy_input = document.createElement('INPUT')
    spicy_input.type = "checkbox"
    spicy_input.classList.add('form-check-input')
    spicy_input.name = "spicy"
    spicy_input.id = "id_spicy"
    if(props.spicy !== null) {
      spicy_input.checked = (props.spicy === 1) ? true : false
    }

    const spicy_label = document.createElement('LABEL')
    spicy_label.htmlFor = "id_spicy"
    spicy_label.classList.add('form-check-label')
    spicy_label.append("{{ l.spicy }}")

    const spicy_cont = document.createElement('DIV')
    spicy_cont.classList.add('form-check')

    spicy_cont.append(spicy_input, spicy_label)

    const spicy = document.createElement('DIV')
    spicy.classList.add('col-12', 'col-lg-4')
    spicy.append(spicy_cont)

    const options_row = document.createElement('DIV')
    options_row.classList.add('form-row')
    options_row.append(spicy, veg, gf)

    add_form.append(options_row)

    return add_form;
  }

  categoryCard = (id, idx, title, foods = null) => {
    const up = document.createElement('I')
    up.classList.add('fa', 'fa-arrow-up')
    up.title = '{{ l.up }}'
    up.onclick = (e) => {
      const mid = Number.parseInt(e.target.closest('.card').dataset.c_order)
      const temp = menu[mid - 1]
      menu[mid - 1] = menu[mid]
      menu[mid] = temp

      refreshMenu()
    }

    const down = document.createElement('I')
    down.classList.add('fa', 'fa-arrow-down')
    down.title = '{{ l.down }}'
    down.onclick = (e) => {
      const mid = Number.parseInt(e.target.closest('.card').dataset.c_order)
      const temp = menu[mid + 1]
      menu[mid + 1] = menu[mid]
      menu[mid] = temp

      refreshMenu()
    }

    const edit = document.createElement('I')
    edit.classList.add('fa', 'fa-pencil')
    edit.title = "{{ l.edit }}"
    let eTitle = ""
    edit.onclick = (e) => {
      const mid = Number.parseInt(e.target.closest('.card').dataset.c_order)
      const inp = document.createElement('INPUT')
      inp.type = 'text'
      inp.onblur = (e) => {
        editCats()
      }

      inp.onkeydown = (e) => {
        if(e.keyCode == 13) {
          editCats()
        } else if (e.keyCode == 27) {
          editCats(false)
        }
      }

      editCats = (update = true) => {
        const mid = Number.parseInt(e.target.closest('.card').dataset.c_order)
        let ttl = inp.value
        if (update === false) {
          ttl = eTitle
        } else {
          menu[mid].cname = ttl
        }
        const title = e.target.parentElement
        title.innerHTML = ttl

        if (update === false) {
          refreshMenu(false)
        } else {
          refreshMenu()
        }
      }

      inp.value = menu[mid].cname
      const title = e.target.parentElement.parentElement.firstChild
      eTitle = title
      title.innerHTML = ""
      title.append(inp)
      inp.focus()
    }

    const del = document.createElement('I')
    del.classList.add('fa', 'fa-times')
    del.title = "{{ l.delete }}"
    del.onclick = (e) => {
      const cid = Number.parseInt(e.target.closest('.card').dataset.cid)
      document.getElementById(`chkbox_${cid}`).checked = true
      e.target.closest('.card-title')
      const catname = e.target.parentElement.parentElement.firstChild.innerText

      showModal({
        m_class: 'delete',
        title: `{{ l.delete }}: ${catname}`,
        body: '{{ l.del_category }}',
        actionText: '{{ l.delete }}',
        actionFunc: () => {
          postData('delete-category', {'id': cid})
          .then(data => {
            menu = data
            refreshMenu(false)
            hideModal()
          })
        }
      })
    }

    const actions = document.createElement('DIV')
    actions.classList.add('actions', 'text-left', 'text-lg-right', 'col-12', 'col-lg-3')
    if(idx != 0) {
      actions.append(up)
    }

    if(idx != menu.length -1) {
      actions.append(down)
    }

    actions.append(edit, del)

    const ttl = document.createElement('LABEL')
    ttl.classList.add('title-container', 'col-9')
    ttl.htmlFor = `chkbox_${id}`
    ttl.append(title)

    const card_header_inner = document.createElement('div')
    card_header_inner.classList.add('row', 'justify-content-between')
    card_header_inner.htmlFor = `chkbox_${id}`
    card_header_inner.append(ttl, actions)

    const card_header = document.createElement('DIV')
    card_header.classList.add('card-header')
    card_header.append(card_header_inner)

    const chkbox = document.createElement("INPUT")
    chkbox.type = "checkbox"
    chkbox.checked = true
    chkbox.classList.add("cat-switch")
    chkbox.id = `chkbox_${id}`

    const additembtn = document.createElement('BUTTON')
    additembtn.classList.add('btn', 'btn-secondary', 'add-item')
    additembtn.append("{{ l.add_item }}")
    additembtn.onclick = (e) => {
      e.preventDefault()
      showModal({
        m_class: 'add-item',
        title: `{{ l.add_item }}{{ l.to_category }} "${title}" {{ l.to_category_2 }}`,
        body: itemForm({}),
        actionText: '{{ l.add_item }}',
        actionFunc: () => {
          data = {
            cid: id,
            title: document.querySelector('#id_title').value,
            description: document.querySelector('#id_description').value,
            s_price: document.querySelector('#id_price_sm').value,
            l_price: document.querySelector('#id_price_lg').value,
            spicy: document.querySelector('#id_spicy').checked,
            veg: document.querySelector('#id_veg').checked,
            gf: document.querySelector('#id_gf').checked
          }
          postData('/add-item', data)
          .then(data => {
            const items = data
            refreshItems(id, items, idx)
            hideModal()
          })
        }
      })
    }

    const cardbody = document.createElement('DIV')
    cardbody.classList.add('card-body')

    const itemlist = document.createElement('DIV')
    itemlist.classList.add('item-list')

    const additembtn2 = additembtn.cloneNode(true)
    additembtn2.onclick = additembtn.onclick

    cardbody.append(additembtn, itemlist, additembtn2)

    const card = document.createElement('DIV')
    card.classList.add('card')
    card.dataset.c_order = idx
    card.dataset.cid = id
    card.append(card_header, chkbox, cardbody)

    return card
  }

  if(typeof menu !== "undefined" && menu !== null && menu.length > 0) {
    refreshMenu(false)
  }
})
